open Ast

module AstEq :
  sig
    val eq_types : Ast.typerep -> Ast.typerep -> bool
    val eq_vars : Ast.var -> Ast.var -> int
    val eq_exps : Ast.exp ref -> Ast.exp ref -> bool
    val esimplify : Ast.exp ref -> Ast.exp ref
  end

module Var :
  sig
    type t = Ast.var 
    val compare : Ast.var -> Ast.var -> int
    val v_str : Ast.var -> string
    val str2var : string -> Ast.varname
  end

module VarMap : Map.S with type key = Var.t
module VarSet : Set.S with type elt = Ast.var

module AstPrint :
  sig
    val exp_depth : Ast.exp ref -> int
    val pickle_type : Ast.typerep -> string
    val pickle_var : Ast.var -> string
    val pickle_exp : Ast.exp ref -> string
    val print_topdecls : Ast.topdecl list -> unit
  end
