#pragma once
#include "ExpressionNodes.h"
#include "ExpDAG.h"
#include "NodeVisitor.h"
#include "VarStore.h"
#include <map>

using namespace std;

class NodeEvaluator :
	public NodeVisitor
{
	//map<UFUN_node*, NodeEvaluator> recursives;
	map<string, ExpDAG*>& functionMap;
	ExpDAG& bdag;
	vector<int> values;
	vector<bool> changes;
	VarStore* inputs;
	bool failedAssert;
	bool trackChange;
	int i(ExpNode& bn){
		return values[bn.globalId];
	}

	bool b(ExpNode& bn){
		return values[bn.globalId] == 1;
	}
	void setbn(ExpNode& bn, int i){
		if(trackChange){
			int id = bn.globalId;
			int& t = values[id];
			changes[id] = changes[id] || (t!=i);
			t = i;
		}else{
			values[bn.globalId] = i;
		}
	}

	void setbn(ExpNode& bn, bool c){
		setbn(bn, c ? 1 : 0);
	}
public:
	NodeEvaluator(map<string, ExpDAG*>& functionMap_p, ExpDAG& bdag_p);
	~NodeEvaluator(void);
	virtual void visit( AndNode& node );
	virtual void visit( OrNode& node );
	virtual void visit( NOT_node& node );
	virtual void visit( PlusNode& node );
	virtual void visit( TimesNode& node );
	virtual void visit( DivNode& node );
	virtual void visit( NEG_node& node );
	virtual void visit( ConstNode& node );
  virtual void visit( SymNode& node );
	virtual void visit( GtNode& node );
	virtual void visit( GeNode& node );
	virtual void visit( LtNode& node );
	virtual void visit( LeNode& node );
	virtual void visit( EqNode& node );
	virtual void visit( NeqNode& node );

	bool run(VarStore& inputs_p);
	void display(ostream& out);
	int scoreNodes();
	void trackChanges(){
		trackChange = true;
	}
	int getValue(ExpNode& bn){
		return i(bn);
	}
	int getValue(ExpNode* bn){
		return i(*bn);
	}
};
