#include "ExpDAGCreator.h"

ExpDAGCreator::ExpDAGCreator(ExpDAG* p_dag):dag(p_dag),optim(*p_dag)
{
	new_names = 0;
	new_namesb = 0;
}

ExpDAGCreator::~ExpDAGCreator(void)
{
	cout<<"nnsize = "<<named_nodes.size()<<endl;
}


ExpNode* ExpDAGCreator::get_node(const vname& name){
  ExpNode* fth;
  Assert(this->dag->assertions.tail == NULL || this->dag->assertions.tail->next == NULL, "this is bad");
  //Assert(name.size()==0 || named_nodes.find(name) != named_nodes.end(), "name does not exist: "<<name);
  if(name == -1) {
    fth = NULL;
  }else{
    if(named_nodes.find(name) != named_nodes.end()){
      fth = named_nodes[name];	
    }else{
      fth = optim.getCnode(-333);
      dag->setOffset(optim.newNodesSize());
    }
  }
  return fth;
}

void ExpDAGCreator::getMotherFather(const vname mother,
    const vname father, /*OUT*/ExpNode*& mth, /*OUT*/ExpNode*& fth){
  Assert(father==-1 || named_nodes.find(father) != named_nodes.end(), "You are using a variable which was never initialized: "<<father);
  Assert(this->dag->assertions.tail == NULL || this->dag->assertions.tail->next == NULL, "this is bad");    
  Assert(mother==-1 ||named_nodes.find(mother) != named_nodes.end(), "You are using a variable which was never initialized: "<< mother);
  
  fth = get_node(father);

  mth = get_node(mother);  
}


ExpNode* ExpDAGCreator::new_node(ExpNode* mother, 
                                ExpNode* father, ExpNode::Type t) {
  ExpNode* fth=father;
  ExpNode* mth=mother;

  /*
  ExpNode* trv = this->optim.quickcse(mth != NULL? mth->globalId: -1, fth != NULL ? fth->globalId : -1, t);
  if(trv != NULL){ return trv; }
  */
#ifdef __TEST
  Assert(this->dag != NULL, "DAG should not be null.");
#endif
  Assert(this->dag->assertions.tail == NULL || this->dag->assertions.tail->next == NULL, "this is bad");

  if(t == ExpNode::AND || t == ExpNode::OR || t == ExpNode::NOT){
	  //Assert( mth->getOtype() == ExpNode::BOOL && (fth == NULL || fth->getOtype() == ExpNode::BOOL), "The parents of a boolean operator must be boolean !!!"<<"  mth="<<mth->get_name()<<"  fth="<<(fth!=NULL? fth->get_name():"NULL"));
  }



  ExpNode* tmp;

//  tmp = dag->new_node(mth, fth, t);    ARMANDO: This is a big performance bug.
  tmp = newBoolNode(t);
#ifdef __TEST
  Assert(tmp != NULL, "new node should not be null");
  Assert( tmp->getType() == t
        , "ExpDAGCreator::new_node: new node should have the right type.");
#endif
  tmp->father = fth;
  tmp->mother = mth;  

  named_nodes[tmp->get_name()] = tmp;
  //tmp->name = name;
/*
  if(t == ExpNode::ASSERT){
	  this->dag->assertions.append( dynamic_cast<AssertNode*>(tmp) );
  }
*/

#ifdef __TEST
  Assert(named_nodes[tmp->get_name()] == tmp, "Node should be added.");
  Assert(tmp != NULL, "new node should not be null after we optimize and add");
  Assert( tmp->getType() == t
        , "ExpDAGCreator::new_node: new node should have the right type after optimizing.");
#endif
  return tmp;
}



ExpNode* ExpDAGCreator::optimizeAndAdd(ExpNode* node){
	
	ExpNode* tmp;
    Assert(this->dag->assertions.tail == NULL || this->dag->assertions.tail->next == NULL, "this is bad");
	/* if(PARAMS->olevel == 0){
		tmp = node;
	}else{ 
		if(PARAMS->olevel == 1){
			tmp = optim.computeCSE(node);
		}else{ */
    // TODO!!!
//			tmp = optim.computeOptim(node);
      tmp = node;
		//}
	//}	
	if(tmp == node){
		optim.addNode(node);
	}else{
		delete node;		
	}
	dag->setOffset(optim.newNodesSize());
	Assert(this->dag->assertions.tail == NULL || this->dag->assertions.tail->next == NULL, "this is bad");
	return tmp;
}




ExpNode* ExpDAGCreator::new_node(ExpNode* mother, 
                                ExpNode* father,  ExpNode* thenode){
  ExpNode* fth=father;
  ExpNode* mth = mother;
  
  ExpNode::Type t = thenode->type;
  
  if(isDllnode(thenode)){
	  Assert(this->dag->assertions.tail == NULL || this->dag->assertions.tail->next == NULL, "this is bad");
	  this->dag->assertions.append( getDllnode(thenode) );
  }

  thenode->father = fth;
  thenode->mother = mth;  
  int s = thenode->get_name();
  thenode = optimizeAndAdd(thenode);
  if(s > -1) {
	  named_nodes[s] = thenode;
  }
  return thenode;
}



void ExpDAGCreator::alias(const vname& ssource,  ExpNode* starg){
  	map<vname, ExpNode*>::iterator it = named_nodes.find(ssource);		
  	if( it != named_nodes.end() ){

		Assert(it->second->mother == NULL, "The mother of the DST node had already been defined. DST="<<ssource);
		it->second->mother = starg;
	}else{
		named_nodes[ssource] = starg;		
  	}
  }



ExpNode* ExpDAGCreator::create_const(int n){
	Assert(this->dag->assertions.tail == NULL || this->dag->assertions.tail->next == NULL, "this is bad");
	ConstNode* c = optim.getCnode(n);
	dag->setOffset(optim.newNodesSize());	
	return c;
}
