#pragma once
#include "ExpressionNodes.h"
#include "ExpDAG.h"
#include "NodeVisitor.h"
#include "VarStore.h"
#include <map>

using namespace std;

class NodeEvaluator :
	public NodeVisitor
{
	//map<UFUN_node*, NodeEvaluator> recursives;
	map<string, ExpDAG*>& functionMap;
	ExpDAG& bdag;
	vector<int> values;
	vector<bool> changes;
	VarStore* inputs;
	bool failedAssert;
	bool trackChange;
	int i(ExpNode& bn){
		return values[bn.id];
	}

	bool b(ExpNode& bn){
		return values[bn.id] == 1;
	}
	void setbn(ExpNode& bn, int i){
		if(trackChange){
			int id = bn.id;
			int& t = values[id];
			changes[id] = changes[id] || (t!=i);
			t = i;
		}else{
			values[bn.id] = i;
		}
	}

	void setbn(ExpNode& bn, bool c){
		setbn(bn, c ? 1 : 0);
	}
public:
	NodeEvaluator(map<string, ExpDAG*>& functionMap_p, ExpDAG& bdag_p);
	~NodeEvaluator(void);
	virtual void visit( AndNode& node );
	virtual void visit( OrNode& node );
	virtual void visit( NOT_node& node );
	virtual void visit( PLUS_node& node );
	virtual void visit( TIMES_node& node );
	virtual void visit( DIV_node& node );
	virtual void visit( NEG_node& node );
	virtual void visit( ConstNode& node );
  virtual void visit( SymNode& node );
	virtual void visit( GT_node& node );
	virtual void visit( GE_node& node );
	virtual void visit( LT_node& node );
	virtual void visit( LE_node& node );
	virtual void visit( EQ_node& node );
	virtual void visit( AssertNode &node);		
	bool run(VarStore& inputs_p);
	void display(ostream& out);
	int scoreNodes();
	void trackChanges(){
		trackChange = true;
	}
	int getValue(ExpNode& bn){
		return i(bn);
	}
	int getValue(ExpNode* bn){
		return i(*bn);
	}
};
