#ifndef NODEVISITOR_H_
#define NODEVISITOR_H_

class AndNode;
class OrNode;
class NOT_node;
class PLUS_node;
class TIMES_node;
class DIV_node;
class NEG_node;
class ConstNode;
class BoolNode;
class RelationNode;
class RecordNode;
class SymNode;
class GT_node;
class GE_node;
class LT_node;
class LE_node;
class EQ_node;
class AssertNode;
class TernaryNode;
class SymNode;

class ExpNode;
class ExpDAG;

class NodeVisitor{
	
	protected:
	virtual void visitBool(ExpNode& node );
	ExpNode* rvalue;
	ExpDAG* tmpdag;
	public:
	
	
	NodeVisitor();
	~NodeVisitor();	
	virtual void visit( AndNode& node );
	virtual void visit( OrNode& node );
	virtual void visit( NOT_node& node );
	virtual void visit( PLUS_node& node );
	virtual void visit( TIMES_node& node );
	virtual void visit( DIV_node& node );
	virtual void visit( NEG_node& node );
	virtual void visit( ConstNode& node );
  virtual void visit( BoolNode& node);
  virtual void visit( RelationNode& node );
  virtual void visit( RecordNode& node );
  virtual void visit( SymNode& node );
	virtual void visit( GT_node& node );
	virtual void visit( GE_node& node );
	virtual void visit( LT_node& node );
	virtual void visit( LE_node& node );
	virtual void visit( EQ_node& node );
	virtual void visit( AssertNode &node);	
  virtual void visit( TernaryNode &node);
	virtual void process(ExpDAG& bdag);
};


#endif /*NODEVISITOR_H_*/
