/**
 *  TODO: Write some comments.
 */
#ifndef VARSTORE_H
#define VARSTORE_H

#include <vector>
#include <string>
#include <map>
#include "BackendTypes.h"
#include "BasicError.h"
#include "ExpressionNodes.h"

using namespace std;

template<typename T> int intFromBV(T& bv, int start, int nbits);

class VarStore{
  private:
    /* A mapping from variable name to internal ID. */
    map<int, int> __varindex;
    int bitsize;

  public:
    /* Information about variables in the variable table. */
    class VarObj{
      public:
        vname __varname;
        bool isNeg;

        VarObj(const vname& nm, int size);
        VarObj(const VarObj& old);
        /* TODO: Move this to CPP file. */
        VarObj& operator=(const VarObj& old) {
          __varname=old.__varname; isNeg = old.isNeg;
          return *this;
        }
    };

  private:
    vector<VarObj> objs;
    /* TODO: Move this to CPP file. */
    VarObj& getObj(const vname& name) { return objs[__varindex[name]]; }

  public:
    VarStore();
    typedef vector<VarObj>::iterator iterator;
    iterator begin();
    iterator end();
    void newVar(const vname& name, int size);
    int getIntsize();
    bool contains(const vname& name) const;
	  //int operator[](const vname& name);
	
    friend VarStore join(const VarStore& v1 , const VarStore& v2);
};

/* When does this join get used? */
inline VarStore join(const VarStore& v1 , const VarStore& v2){
	VarStore rv = v1;
	int sz = v1.objs.size();
	rv.objs.insert(rv.objs.end(), v2.objs.begin(), v2.objs.end());
	for(map<int, int>::const_iterator it = v2.__varindex.begin();
      it != v2.__varindex.end(); ++it){
		rv.__varindex[it->first] = it->second + sz;
	}
	rv.bitsize = v1.bitsize + v2.bitsize;
	return rv;
}

#endif

