#ifndef __BACKEND_IFACE_H
#define __BACKEND_IFACE_H

#include "backend_defs.h"
#include "BackendEnv.h"
#include "BasicError.h"

class BackendIface {
 public:
  BackendIface() { }
  ~BackendIface() { }

  static BackendEnv* env;
  static BackendEnv* getEnv() {
    Assert(env != NULL, "Backend environment is not null.");
    return env;
  }

  static BoolNode* true_node;
  static BoolNode* false_node;
  static eid_t getBoolNode(bool val) {
    if (val) {
      return true_node->get_name();
    } else {
      return false_node->get_name();
    }
  }
};

BackendEnv* BackendIface::env = new BackendEnv();
BoolNode* BackendIface::true_node = new BoolNode(1);
BoolNode* BackendIface::false_node = new BoolNode(0);

#endif /* __BACKEND_IFACE_H */
