#ifndef DAGCSE_H_
#define DAGCSE_H_

#include "ExpDAG.h"
#include "timerclass.h"
#include "StringHTable.h"


#define Dtime(...) /*nothing*/


class DagCSE : public NodeVisitor
{	
	ExpDAG& dag;	
	StringHTable2<ExpNode*> cse_map;
	vector<char> tmpbuf;
	/*
	inline bool hasCSE(string& str){
		Dtime(maptimer.restart();)
		bool tmp = cse_map.find(str) != cse_map.end(); 		
		Dtime(maptimer.stop();)
		return tmp;
	}*/
	/*
	inline  ExpNode* operator[](const string& str)const{
		Dtime(maptimer.restart();)
		 ExpNode* tmp;
		cse_map.get(str.c_str(), tmp);
		Dtime(maptimer.stop();)
		return tmp;	
	} 
	*/
public:

	string ccode;
	Dtime(timerclass stimer;)
	Dtime(timerclass maptimer;)
	DagCSE(ExpDAG& p_dag);
	virtual ~DagCSE();	
	int cheapStr(int id1, char op, int id2);
	void eliminateCSE();
	/*
	inline void setCSE(ExpNode* node){
		node->accept(*this);
		(*this)[this->ccode] = node;
	}
	*/

	ExpNode* quickcse(int idmom, int idpop, ExpNode::Type t);

	inline  ExpNode* computeCSE( ExpNode* node){
		node->accept(*this);
		//cout<<node<<" ccode = "<<ccode<<endl;
		
		ExpNode* rv;
		cse_map.condAdd(this->ccode.c_str(), this->ccode.size(), node, rv);
		return rv;
	}


	inline void clear(){
		cse_map.clear();
	}

	void setStr(int id1, char op, int id2);
	
	virtual void visit(  AndNode& node );
	virtual void visit(  OrNode& node );
	virtual void visit(  NOT_node& node );	
	virtual void visit(  PlusNode& node );
	virtual void visit(  TimesNode& node );
	virtual void visit(  DivNode& node );
	virtual void visit(  ConstNode& node );
  virtual void visit(  SymNode& node );
	virtual void visit(  NEG_node& node);
	virtual void visit(  GtNode& node );
	virtual void visit(  GeNode& node );
	virtual void visit(  LtNode& node );
	virtual void visit(  LeNode& node );
	virtual void visit(  EqNode& node );
	virtual void visit(  AssertNode &node);	
};

#endif /*DAGCSE_H_*/
