#ifndef NODEVISITOR_H_
#define NODEVISITOR_H_

class AndNode;
class OrNode;
class NOT_node;
class PlusNode;
class TimesNode;
class DivNode;
class NEG_node;
class ConstNode;
class BoolNode;
class RelationNode;
class RecordNode;
class SymNode;
class GtNode;
class GeNode;
class LtNode;
class LeNode;
class EqNode;
class NeqNode;
class AssertNode;
class TernaryNode;
class SymNode;

class ExpNode;
class ExpDAG;

class NodeVisitor {

protected:
	virtual void visitBool(ExpNode& node);
	ExpNode* rvalue;
	ExpDAG* tmpdag;
public:
	NodeVisitor();
	~NodeVisitor();
	virtual void visit(AndNode& node);
	virtual void visit(OrNode& node);
	virtual void visit(NOT_node& node);
	virtual void visit(PlusNode& node);
	virtual void visit(TimesNode& node);
	virtual void visit(DivNode& node);
	virtual void visit(NEG_node& node);
	virtual void visit(ConstNode& node);
	virtual void visit(BoolNode& node);
	virtual void visit(RelationNode& node);
	virtual void visit(RecordNode& node);
	virtual void visit(SymNode& node);
	virtual void visit(GtNode& node);
	virtual void visit(GeNode& node);
	virtual void visit(LtNode& node);
	virtual void visit(LeNode& node);
	virtual void visit(EqNode& node);
	virtual void visit(NeqNode& node);
	virtual void visit(AssertNode &node);
	virtual void visit(TernaryNode &node);
	virtual void process(ExpDAG& bdag);
};


#endif /*NODEVISITOR_H_*/
