/**
 *  This file defines different kinds of Boolean nodes.
 */
#include "ExpressionNodes.h" 

using namespace std;

InterNode::InterNode(const InterNode& bn): ExpNode(bn), nbits(bn.nbits){ }
InterNode::InterNode(){nbits = 1;}

int InterNode::get_nbits() const { return nbits; }
void InterNode::set_nbits(int n){ nbits = n; }

ExpNode::OutType InterNode::getOtype() const {
  if(otype != BOTTOM){
    return otype;
  }
  if(nbits>1){
    otype = INT;
  }else{
    otype = BOOL;
  }
  return otype;
}

string InterNode::get_namestr() const{
  stringstream str;
  if(__name > -1)
    str<<__name<<"__"<<get_tname();
  else{
    str<<"name_"<<abs(id)<<"_"<<"__"<<get_tname();

  }
  Assert( id != -22, "This is a corpse. It's living gargabe "<<str.str()<<" id ="<<id );
  return str.str();
}

string InterNode::lprint(){
  stringstream str;
  str << __name;
  return str.str();
}

string InterNode::lid() {
  return lprint();
}

SymNode::SymNode(){ type = SYM; }

SymNode::SymNode(const SymNode& bn): InterNode(bn){ }

SymNode::SymNode(const vname& nm){
  type = SYM;
  __name = nm;
}

void SymNode::accept(NodeVisitor& visitor) {
  visitor.visit( *this );
}
ExpNode* SymNode::clone(bool copyChildren) {
  return new SymNode(*this);
};

ExpNode::Type SymNode::getType() const { return SYM; }

void SymNode::addVars(set<int>& vars) {
#ifndef __DEBUG_1
  cout << "SymNode::addVars: Adding " << __name << "." << endl;
#endif
  vars.insert(__name);
}

string SymNode::get_yicesstr() const {
  stringstream str;
  str << "v" << __name;
  return str.str();
}
