#include "VarStore.h"

using namespace std;

template<typename T>
int intFromBV(T& bv, int start, int nbits){
	int nval = 0;	
	int t = 1;
	
	for(int i=0; i<nbits; ++i){		
		if( bv[start + i] > 0){
			nval += t;	
		}
		t = t*2;
	}
	return nval;
}

/**
 * Internal class VarObj definitions.
 * NOTE(JY): What the heck is VarObj?
 */
/* Constructors. */
VarStore::VarObj::VarObj(const int& nm, int size) : 
  __varname(nm), isNeg(false) { }
VarStore::VarObj::VarObj(const VarObj& old) :
  __varname(old.__varname), isNeg(old.isNeg) { }

/**
 * VarStore functions.
 */
/*
VarStore::VarObj& getObj(const string& name){ 
  return objs[index[name]];
}
*/

VarStore::VarStore(){
  bitsize=0;
}	

VarStore::iterator VarStore::begin(){ return objs.begin(); }
VarStore::iterator VarStore::end(){ return objs.end(); }

void VarStore::newVar(const vname& name, int size){
  Assert(__varindex.count(name)==0, "This variable already existed!!");
  objs.push_back(VarObj(name, size));
  __varindex[name] = objs.size()-1;
  bitsize += size;
}

int VarStore::getIntsize(){
  return objs.size();
}

bool VarStore::contains(const vname& name) const{
  return __varindex.count(name)>0;
}

/*
int VarStore::operator[](const vname& name) {
  return objs[__varindex[name]].getInt();
}
*/
