#include <caml/mlvalues.h>
#include "BackendRep/backend_defs.h"

void popNode();
void dupNode();
void swapNode();
void pushUnitNode();

void readExpRelation(int numfields, char* file);
void mkEnvRelation(int name, int numfields);

void bindEnvRelationVal(int rname, int field);
void lookupEnvRelationVal(int rname, int field);
void lookupEnvFieldIndex(int rname, int field);
void lookupEnvFieldIndexHidden(int rname, int field);
int getRelIterator();
int getNextRecord();

void listElemEnv();

CAMLprim void pop() {
  popNode();
}

CAMLprim void dup() {
  dupNode();
}

CAMLprim void swap() {
  swapNode();
}

CAMLprim void pushUnit() {
  pushUnitNode();
}

/**
 * Given a file name, this function calls a function that reads in a relation.
 */
CAMLprim value readRelation(value numfields, value filename) {
  readExpRelation(Int_val(numfields), String_val(filename));
}

CAMLprim value mkRelation(value rname, value numfields) {
  mkEnvRelation(Int_val(rname), Int_val(numfields));
}

/**
 *
 */
void bindRelationVal(value rname, value field) {
  bindEnvRelationVal(Int_val(rname), Int_val(field));
}

CAMLprim value lookupRelationVal(value rname, value field) {
  lookupEnvRelationVal(Int_val(rname), Int_val(field));
}

CAMLprim value lookupFieldIndex(value rname, value field) {
  lookupEnvFieldIndex(Int_val(rname), Int_val(field));
}

CAMLprim value lookupFieldIndexHidden(value rname, value field) {
    lookupEnvFieldIndexHidden(Int_val(rname), Int_val(field));
}

/**
 * Returns an integer ID corresponding to the iterator.
 */
CAMLprim void relIterator() {
  getRelIterator();
}

CAMLprim void relPkeyIterator(value varname) {
  getRelPkeyIterator(Int_val(varname));
}

CAMLprim value nextRecord() {
  return Val_bool(getNextRecord());
}

/**
 * TODO: Implement record select.
 */
CAMLprim value recordSelect(value field, value val) {
  return 0;
}

CAMLprim void listElem() {
  return listElemEnv();
}
