(*
    Module      : censusdata.ty

    This file declares the census data type:

    data census_data { name : int
                 ; dob : int
                 ; age : int
                  (* TODO: Eventually support booleans; have ints for now. *)
                 ; married : bool
                 ; spouse : int
                 ; mother : int
                 ; father : int
                  (* NOTE: Just have child singular for now... *)
                  (* TODO: Support this list type business. *)
                 ; children : int list }
 *)
module Ast = Ast.Ast

let census_fields =
  [ ("name"     , Ast.IntType)
  ; ("age"      , Ast.IntType)
  ; ("married"  , Ast.IntType)
  ; ("spouse"   , Ast.IntType)
  ; ("child"    , Ast.IntType)
  ]

let censusty =
  { Ast.dataname = "censusty"
  ; Ast.fieldinfo = census_fields }
