let file_path = ref ""
let set_file_path (fp : string) = file_path := fp

let send_str = ref "default string"
let set_send_str (ss : string) = send_str := ss

(* Specifications for command-line arguments. *)
let cmd_specs =
  [ ("-filepath", Arg.String set_file_path, "file path")
  ; ("-sendstr", Arg.String set_send_str, "string to send") ]
let anon_fun x = print_endline x
let usage_message = "Please use the following options."

let sock_send sock str =
            let len = String.length str in
    Unix.send sock str 0 len []

let client = Unix.socket Unix.PF_INET Unix.SOCK_STREAM 0
let run_client () =
  let send_str = !send_str in
  (* Connect to server. *)
  try
    let hentry = Unix.gethostbyname "sketch1" in
    (Unix.connect client (Unix.ADDR_INET (hentry.Unix.h_addr_list.(0), 1029));
     sock_send client send_str)
  with err ->
    (match err with
      | Unix.Unix_error (err, fn, param) ->
        (print_endline (Unix.error_message err); -1)
      | _ -> (print_endline "other error"); -2)

let main () =
  Arg.parse cmd_specs anon_fun usage_message;
  run_client ()

let _ = Printexc.print main ()
