exception Undefined

exception ParseUndefinedVar of string
exception ParseUndefinedType of string
exception ParseUnexpected of string

exception SymbolicExp
exception Impossible of string
exception Unimplemented of string
exception InputError of string
exception InternalError of string

exception Unbound of string (* variable *)
                   * string (* context *)
exception Unexpected of string

exception TypeError of string

exception File_required

(* Couldn't find things. *)
exception FunctionUndefined of string
exception ArgError of int * int

exception Unsat

let debug = ref 0
let set_debug debug_level =
  debug := debug_level;
  ()
let debug_level level = level <= !debug
let debug_print level msg =
  if level <= !debug
  then print_endline msg
  else ()
