(*
    Module        : oracle.ml
    Last updated  : 11.11.10
    Maintainer    : jeanyang@csail.mit.edu
 *)
open AstUtils
open BackendInterface
open Error
open Evalenv

module Ast = Ast.Ast

module Oracle =
struct
  (*
   * Concretize an expression.  All variables that appear in the expression
   * need to be mapped to a concrete value.
   *)
  (* TODO: Add context. *)
  let concretize
        (env : Evalenv.evalenv ref)
        (ctxt : int) (e : Ast.exp ref) (t : Ast.typerep)
        : unit =
    let _ = EvalExp.evalExp env e t in
    let start_time = Sys.time () in
    let _ = BackendInterface.resolveWithContext ctxt in
    let end_time = Sys.time () in
      Time.update_time (end_time -. start_time)
end
