'''
Processing files that have record struction
  [household] [line] [age] [married] [spouse]
'''
import sys
import time

input_rel = []
input_rel_by_household = {}

def readFromFile(filename):
  f = open(filename, 'r')
  data_lines = f.readlines()
  for line in data_lines:
    line = line.rstrip();
    line_fields = line.split()
    if len(line_fields) == 5:
      # Add to our list of input records.
      input_rel.append(line_fields)
      # Also add to our dictionary by household.
      household = line_fields[0]
      if input_rel_by_household.has_key(household):
        input_rel_by_household[household].append(line_fields)
      else:
        input_rel_by_household[household] = [line_fields]

def sumInputRelMarriedAge():
  age_sum = 0
  for entry in input_rel:
    if entry[3] == "1":
      age_sum = age_sum + int(entry[2])
    elif entry[3] == "!!":
      # If the entry is missing, loop over the list of records in the same
      # household to find if someone lists the current person as their spouse.
      for housemate in input_rel_by_household[entry[0]]:
        if housemate[4] == entry[1]:
          age_sum = age_sum + int(entry[2])
  print age_sum

def main():
  # Read from file.
  readFromFile(sys.argv[1])
  sumInputRelMarriedAge()
  print time.clock()

if __name__ == "__main__":
  main()
