open AstUtils
open BackendInterface
open Error
open Evalenv

module Ast = Ast.Ast
module Evaluator = Evaluator.Evaluator
module TestUtils = TestUtils.TestUtils

(* Define a data type. *)
let dataty_name = TestUtils.gen_var ()
let v = TestUtils.gen_var ()
let dataty =
  { Ast.dataname = dataty_name; Ast.fieldinfo = [(0, Ast.IntType)] }
let tydecl =
  let rel = TestUtils.gen_var () in
  let mconstraint =
    let v = TestUtils.gen_var () in
    let incc = TestUtils.mkACBoolop Ast.Gt
                (ref (Ast.VarExp (Ast.FieldIndexVar (v, 0))))
                (ref (Ast.PrimExp (Ast.Integer 0))) in
      Ast.ConstraintForall (v, rel, Ast.ref_true, Ast.CExp incc) in
    Ast.TypeDecl (dataty, rel, [mconstraint])

(* Declare a relation. *)
let input_list =
    [ (0, ["1"])
    ; (1, ["2"])
    ; (2, ["??"])
    ; (3, ["4"]) ]
let indata_name = TestUtils.gen_var ()
let indata =
  fun _ -> TestUtils.mkRelFromList indata_name dataty_name 1 input_list
let assign_in = Ast.AssignDecl ( indata_name
                               , Ast.RelationType dataty_name
                               , (Ast.RhsExp (Ast.VarExp (Ast.Var indata_name))) )

(* TEST PROGRAM 0 *)
(* Program 0 just reads in input and concretizes it. *)
let program0 =
  fun _ ->
    indata ();
    [ tydecl
        ; assign_in
            ; TestUtils.mkConcreteResult
                TestUtils.result_name
                (Ast.RelationType dataty_name) indata_name ]
let check_program0 (e : Ast.exp ref) : unit =
  print_endline (AstPrint.pickle_exp e)

(* Program 1 does a bounded sum. *)
(* TODO: Write program 1. *)

(*** CHECKING *)
let check_result (program, check_result) =
  let denv = ref Evalenv.empty_evalenv in
  print_endline "---";
  (* AstPrint.print_topdecls (program ());
  print_endline "---"; *)
  Evaluator.evaluate denv (program ());
  print_endline "Getting result...";
  Evalenv.lookupValueEnv denv (Ast.Var TestUtils.result_name)
    (*
  | Some te -> check_result te
  | None -> raise (Impossible "no result") *)

let run_bounded_tests () = raise Undefined
                             (*
  print_endline "*** RUNNING BOUNDED TESTS ***";
  let tests = [ (program0, check_program0) ] in
    List.iter check_result tests *)
