open Ast

module TestUtils :
sig
  exception TestUnexpected of string
  exception TestFail of string

  val gen_var : unit -> Ast.varname
  val result_name : Ast.varname
  val mkConcreteResult : Ast.varname -> Ast.typerep -> Ast.varname -> Ast.topdecl

  val assert_exp_eq : Ast.exp ref -> Ast.exp ref -> unit
  val assert_ty_eq : Ast.typerep -> Ast.typerep -> unit

  (* AST construction. *)
  val mkFieldIndex : Ast.varname -> Ast.fieldname -> Ast.exp ref
  val mkArithop : Ast.binop -> Ast.exp ref -> Ast.exp ref -> Ast.exp ref
  val mkBoolop : Ast.boolop -> Ast.exp ref -> Ast.exp ref -> Ast.exp ref
  val mkRelation : Ast.varname -> Ast.typename -> int
                -> (int * Ast.exp ref list) list
                -> unit
  val mkRelFromList : Ast.varname -> Ast.typename -> int
                   -> (int * string list) list -> unit

  (* Constraint construction. *)
(*  val mkACFieldIndex : Ast.varname -> Ast.fieldname -> Ast.cexp ref *)
  val mkACBoolop : Ast.boolop -> Ast.exp ref -> Ast.exp ref -> Ast.exp ref
end
