data timedata { timestamp  :: ~int
              , uid :: int
              , value  :: int }
let input_data :: relation timedata = input data/temp

(* These assertions would generate constraints based on the positions of
   elements in the input list.
*)
@@ input_data {
  increasing timestamp.
}

(* 2 requirements on a change set: they occur within some timeframe and were
   made by the same user. *)
data timecluster { timestamp :: int
                   , uid :: int
                   , value :: int
                   , groupid :: int
                  }

function make_changesets (cdata :: relation timedata) = {
  let groupid = 0;

  let curuid = 100;
  let curtimestamp = 0;

  foreach cvsentry in cdata {
    (* If the timestamps are far enough apart, start a new guy. *)
    if ((cvsentry.timestamp - curtimestamp) > 5) {
      let groupid = groupid + 1;
      let curuid = cvsentry.uid;
      let cvsentry.gid = groupid;
    } else {
      if (cvsentry.uid != curuid) {
        let groupid = groupid + 1;
        let curuid = cvsentry.uid;
        let cvsentry.gid = groupid;
      } else {
        let groupid = groupid;
        let curuid = cvsentry.uid;
        let cvsentry.gid = groupid;
      }
    }
    let curtimestamp = cvsentry.timestamp;
  }
}
let result :: relation changeset = make_changesets input_data
