(*
  Tests the basic functionalities of the LogLog interpreter.
*)
open AstUtils
open BackendInterface
open Error
open Evalenv

exception TestFail of string

(* Specifications for command-line arguments. *)
let cmd_specs =
  [ ("-debug",  Arg.Int set_debug,          "debug?") ]
let anon_fun x = print_endline x
let usage_message = "Please use the following options."

(* Main stuff. *)
let main () =
  Arg.parse cmd_specs anon_fun usage_message;
  print_endline "Initializing environment...";
  BackendInterface.initEnv ();
  SimpleResult.run_simple_tests ()
(*  BoundedSum.run_bounded_tests () *)

let _ = Printexc.print main ()
