(* Utils *)

(* Set operations *)
let nub (compare : 'a -> 'a -> int) (lst : 'a list) : ('a list) =
  let rec nub_h acc x =
    if (List.exists (fun e -> (compare e x) == 0) acc)
      then acc
      else (x::acc) in
    List.fold_left nub_h [] lst

let union lst1 lst2 =
  List.fold_left
    (fun acc -> fun elt ->
      if (List.exists (fun x -> x == elt) acc) then acc else elt::acc) lst1 lst2

(* Converts lines from strings to the appropriate data value. *)
(* let split = Str.split (Str.regexp_string " ");; *)
let rec zip lst1 lst2 = match lst1, lst2 with
  | [], _ -> []
  | _, [] -> []
  | (x::xs), (y::ys) -> (x, y)::(zip xs ys);;

(* Generate fresh variables. All internal logic variables have the form
   _v[num]. *)
let varcount = ref 0 ;;
let genvar () : string =
  let newvar = String.concat "" ["_v"; string_of_int !varcount] in
    varcount := !varcount + 1;
    newvar
